#-----------------------------------------------------------------------------
%{?!dist:	%define	dist		.ok}
%define			appname		apache
%define			_httpd_moddir	%{_libdir}/httpd/modules
#-----------------------------------------------------------------------------
Name		:	php
Version		:	8.3.12
Release		:	17.2.0.rel%{?dist}

Summary		:	PHP scripting language for creating dynamic web sites
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	PHP
URL		:	http://www.php.net/distributions

Source0		:	%{name}-%{version}.tar.xz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
Buildrequires	:	autoconf
Buildrequires	:	apr-util-devel
Buildrequires	:	dovecot
Buildrequires	:	curl
Buildrequires	:	enchant
Buildrequires	:	gcc
Buildrequires	:	gcc-c++
Buildrequires	:	httpd
Buildrequires	:	libgd-devel
Buildrequires	:	linux-headers
Buildrequires	:	libxml2-devel
Buildrequires	:	libxslt
Buildrequires	:	net-snmp-devel
Buildrequires	:	openldap-devel
Buildrequires	:	oniguruma-devel
Buildrequires	:	m4
Buildrequires	:	make
Buildrequires	:	mariadb
Buildrequires	:	unixODBC-devel
Buildrequires	:	pcre
Buildrequires	:	sqlite

Recommends	:	httpd

Requires	:	libgd

Obsoletes	:	%{name}.common <= 7.4.16

Provides	:	%{name}-bz2
Provides	:	%{name}-calendar
Provides	:	%{name}-ctype
Provides	:	%{name}-curl
Provides	:	%{name}-date
Provides	:	%{name}-dba
Provides	:	%{name}-exif
Provides	:	%{name}-fileinfo
Provides	:	%{name}-filter
Provides	:	%{name}-ftp
Provides	:	%{name}-gettext
Provides	:	%{name}-hash
Provides	:	%{name}-iconv
Provides	:	%{name}-json
Provides	:	%{name}-mbstring
Provides	:	%{name}-pcre
Provides	:	%{name}-phar
Provides	:	%{name}-openssl
Provides	:	%{name}-posix
Provides	:	%{name}-reflection
Provides	:	%{name}-session
Provides	:	%{name}-shmop
Provides	:	%{name}-sockets
Provides	:	%{name}-spl
Provides	:	%{name}-sysvmsg
Provides	:	%{name}-sysvsem
Provides	:	%{name}-sysvshm
Provides	:	%{name}-tokenize
Provides	:	%{name}-zlib

#-----------------------------------------------------------------------------
%description
PHP, which stands for "PHP: Hypertext Preprocessor" is a widely-used
Open Source general-purpose scripting language that is especially
suited for web development and can be embedded into HTML. Its syntax
draws upon C, Java, and Perl, and is easy to learn. The main goal of
the language is to allow web developers to write dynamically generated
web pages quickly, but you can do much more with PHP. 

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%license LICENSE
%doc CONTRIBUTING.md NEWS README.md
%config(noreplace) %{_sysconfdir}/%{name}.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-bz2.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-calendar.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-ctype.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-curl.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-dba.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-exif.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-fileinfo.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-ftp.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-gettext.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-iconv.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-mbstring.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-phar.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-posix.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-shmop.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sockets.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sysvmsg.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sysvsem.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sysvshm.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-tokenizer.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-zlib.ini
%{_libdir}/%{name}/modules/bz2.so
%{_libdir}/%{name}/modules/calendar.so
%{_libdir}/%{name}/modules/ctype.so
%{_libdir}/%{name}/modules/curl.so
%{_libdir}/%{name}/modules/dba.so
%{_libdir}/%{name}/modules/exif.so
%{_libdir}/%{name}/modules/fileinfo.so
%{_libdir}/%{name}/modules/ftp.so
%{_libdir}/%{name}/modules/gettext.so
%{_libdir}/%{name}/modules/iconv.so
%{_libdir}/%{name}/modules/mbstring.so
%{_libdir}/%{name}/modules/phar.so
%{_libdir}/%{name}/modules/posix.so
%{_libdir}/%{name}/modules/shmop.so
%{_libdir}/%{name}/modules/sockets.so
%{_libdir}/%{name}/modules/sysvmsg.so
%{_libdir}/%{name}/modules/sysvsem.so
%{_libdir}/%{name}/modules/sysvshm.so
%{_libdir}/%{name}/modules/tokenizer.so
%{_libdir}/%{name}/modules/zlib.so

#=============================================================================
%package		devel
Summary		:	files needed for building PHP extensions

Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The php-devel package contains the files needed for building PHP
extensions. If you need to compile your own PHP extensions, you will
need to install this package.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/%{name}-config
%{_includedir}/%{name}/*
%{_libdir}/%{name}/build/*
%{_mandir}/man1/php-config.1.gz

#=============================================================================
%package		cli
Summary		:	Command-line interface for PHP

License		:	PHP and Zend and BSD and MIT and ASL 1.0 and NCSA and PostgreSQL

Requires	:	%{name}			= %{version}-%{release}

Provides	:	%{name}-cgi		= %{version}-%{release}
Provides	:	%{name}-pcntl		= %{version}-%{release}
Provides	:	%{name}-phar		= %{version}-%{release}
Provides	:	%{name}-readline	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		cli
The php-cli package contains the command-line interface
executing PHP scripts, /usr/bin/php, and the CGI interface.

#-----------------------------------------------------------------------------
%files			cli
%{_bindir}/%{name}
%{_bindir}/%{name}-cgi
%{_bindir}/phar.phar
%{_bindir}/phar
%{_bindir}/phpize
%{_mandir}/man1/%{name}.1.gz
%{_mandir}/man1/%{name}-cgi.1.gz
%{_mandir}/man1/phar.1.gz
%{_mandir}/man1/phar.phar.1.gz
%{_mandir}/man1/phpize.1.gz

#=============================================================================
%package		apache
Summary		:	Apache  components for PHP

License		:	PHP and Zend and BSD and MIT and ASL 1.0 and NCSA and PostgreSQL

Requires	:	%{name}		= %{version}-%{release}
Requires	:	shadow

#-----------------------------------------------------------------------------
%description		apache
The package contains the library executing PHP scripts within
apache context.

#-----------------------------------------------------------------------------
%files			apache
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%attr(0770,root,apache) %dir %{_sharedstatedir}/%{name}/session
%{_httpd_moddir}/libphp.so

#-----------------------------------------------------------------------------
%pre			apache
#after upgrade or remove
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{appname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{appname}
    /usr/sbin/useradd 				\
	-r					\
	-c "Apache Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{appname}				\
	-s /sbin/nologin			\
	-d %{_sysconfdir}/%{name}		\
	%{appname}
    fi
  fi

%postun			apache
if [ "$1" = 0 ]; then
  if [ ! -f /etc/rc.d/init.d/httpd ] ; then
    /usr/sbin/userdel %{appname}
    fi
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi


#=============================================================================
%package		dbg
Summary		:	The interactive PHP debugger
License		:	PHP


Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		dbg
The php-dbg package contains the interactive PHP debugger.

#-----------------------------------------------------------------------------
%files			dbg
%defattr(-,root,root,-)
%doc sapi/phpdbg/{README.md,CREDITS}
%{_bindir}/phpdbg
%{_mandir}/man1/phpdbg.1.gz*

#=============================================================================
%package		enchant
Summary		:	Enchant spelling extension for PHP applications
License		:	PHP

BuildRequires	:	enchant
BuildRequires	:	openssl-devel

Requires	:	%{name}			= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		enchant
The php-enchant package contains a dynamic shared object that will add
support for using the enchant library to PHP.

#-----------------------------------------------------------------------------
%files			enchant
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-enchant.ini
%{_libdir}/%{name}/modules/enchant.so

#=============================================================================
%package		fpm
Summary		:	PHP FastCGI Process Manager
License		:	PHP


Requires	:	%{name}-apache	= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		fpm
PHP-FPM (FastCGI Process Manager) is an alternative PHP FastCGI
implementation with some additional features useful for sites of
any size, especially busier sites.

#-----------------------------------------------------------------------------
%files			fpm
%license fpm_LICENSE
%{_sysconfdir}/rc.d/init.d/%{name}-fpm
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}-fpm.lr
%config(noreplace) %{_sysconfdir}/%{name}/%{name}-fpm.conf
%config(noreplace) %{_sysconfdir}/%{name}/%{name}-fpm.d/www.conf
%dir %{_var}/log/%{name}-fpm/
%{_sbindir}/%{name}-fpm
%{_mandir}/man8/%{name}-fpm.8.gz
%{_datadir}/%{name}/fpm/status.html

#-----------------------------------------------------------------------------
%preun			fpm
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}-fpm
  (
  /bin/echo -n "%{name}-fpm-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-fpm-removed
  fi

%post			fpm
%{_sbindir}/chkconfig --add %{name}-fpm
%{_sysconfdir}/rc.d/init.d/%{name}-fpm condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		gd
Summary		:	A module for PHP applications for using the gd graphics librar
License		:	PHP

Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		gd
The php-gd package contains a dynamic shared object that will add
support for using the gd graphics library to PHP.

#-----------------------------------------------------------------------------
%files			gd
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-gd.ini
%{_libdir}/%{name}/modules/gd.so

#=============================================================================
%package		gmp
Summary		:	 A module for PHP applications for using the GNU MP library
License		:	PHP

BuildRequires	:	gmp

Requires	:	%{name}			= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		gmp
These functions allow you to work with arbitrary-length integers
using the GNU MP library.

#-----------------------------------------------------------------------------
%files			gmp
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-gmp.ini
%{_libdir}/%{name}/modules/gmp.so

#=============================================================================
%package		intl
Summary		:	Internationalization extension for PHP applications
License		:	PHP

BuildRequires	:	icu
BuildRequires	:	openssl-devel

Requires	:	%{name}			= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		intl
The php-intl package contains a dynamic shared object that will add
support for using the ICU library to PHP.

#-----------------------------------------------------------------------------
%files			intl
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-intl.ini
%{_libdir}/%{name}/modules/intl.so

#=============================================================================
%package		ldap
Summary		:	A module for PHP applications that use LDAP
License		:	PHP

BuildRequires	:	openldap-devel
BuildRequires	:	openssl-devel

Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		ldap
The php-ldap adds Lightweight Directory Access Protocol (LDAP)
support to PHP. LDAP is a set of protocols for accessing directory
services over the Internet. PHP is an HTML-embedded scripting
language.

#-----------------------------------------------------------------------------
%files			ldap
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-ldap.ini
%{_libdir}/%{name}/modules/ldap.so

#=============================================================================
%package		mysqlnd
Summary		:	A module for PHP applications that use MySQL databases
License		:	PHP

Requires	:	%{name}-pdo		= %{version}-%{release}

Provides	:	%{name}-mysqli		= %{version}-%{release}
Provides	:	%{name}-pdo_mysql	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		mysqlnd
The php-mysqlnd package contains a dynamic shared object that will add
MySQL database support to PHP. MySQL is an object-relational database
management system. PHP is an HTML-embeddable scripting language. If
you need MySQL support for PHP applications, you will need to install
this package and the php package.
 
This package use the MySQL Native Driver

#-----------------------------------------------------------------------------
%files			mysqlnd
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-mysqlnd.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/30-mysqli.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/30-pdo_mysql.ini
%{_libdir}/%{name}/modules/mysqli.so
%{_libdir}/%{name}/modules/mysqlnd.so
%{_libdir}/%{name}/modules/pdo_mysql.so

#=============================================================================
%package		odbc
Summary		:	A module for PHP applications that use ODBC databases
License		:	PHP

Requires	:	%{name}			= %{version}-%{release}
Requires	:	%{name}-pdo		= %{version}-%{release}

Provides	:	%{name}-pdo_odbc	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		odbc
The php-odbc package contains a dynamic shared object that will add
database support through ODBC to PHP. ODBC is an open specification
which provides a consistent API for developers to use for accessing
data sources (which are often, but not always, databases). PHP is an
HTML-embeddable scripting language. If you need ODBC support for PHP
applications, you will need to install this package and the php
package.

#-----------------------------------------------------------------------------
%files			odbc
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/30-pdo_odbc.ini
%{_libdir}/%{name}/modules/pdo_odbc.so

#=============================================================================
%package		pdo
Summary		:	A database access abstraction module for PHP applications
License		:	PHP

Requires	:	%{name}		= %{version}-%{release}

Provides	:	%{name}-pdo		= %{version}-%{release}
Provides	:	%{name}-pdo_sqlite	= %{version}-%{release}
Provides	:	%{name}-sqlite3		= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		pdo
The php-pdo package contains a dynamic shared object that will add
a database access abstraction layer to PHP.  This module provides
a common interface for accessing MySQL, PostgreSQL or other

#-----------------------------------------------------------------------------
%files			pdo
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-pdo.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/30-pdo_sqlite.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sqlite3.ini
%{_libdir}/%{name}/modules/pdo.so
%{_libdir}/%{name}/modules/sqlite3.so
%{_libdir}/%{name}/modules/pdo_sqlite.so

#=============================================================================
%package		pgsql
Summary		:	A PostgreSQL database module for PHP
License		:	PHP

BuildRequires	:	openssl-devel
BuildRequires	:	postgresql-server-devel

Requires	:	%{name}-pdo		= %{version}-%{release}

Provides	:	%{name}-pgsql		= %{version}-%{release}
Provides	:	%{name}-pdo_pgsql	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		pgsql
The php-pgsql package add PostgreSQL database support to PHP.
PostgreSQL is an object-relational database management
system that supports almost all SQL constructs. PHP is an
HTML-embedded scripting language. If you need back-end support for
PostgreSQL, you should install this package in addition to the main
php package.

#-----------------------------------------------------------------------------
%files			pgsql
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-pgsql.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/30-pdo_pgsql.ini
%{_libdir}/%{name}/modules/pdo_pgsql.so
%{_libdir}/%{name}/modules/pgsql.so

#=============================================================================
%package		snmp
Summary		:	A module for PHP applications that query SNMP-managed device
License		:	PHP

BuildRequires	:	net-snmp-devel


#-----------------------------------------------------------------------------
%description		snmp
The php-snmp package contains a dynamic shared object that will add
support for querying SNMP devices to PHP.  PHP is an HTML-embeddable
scripting language. If you need SNMP support for PHP applications, you
will need to install this package and the php package.

#-----------------------------------------------------------------------------
%files			snmp
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-snmp.ini
%{_libdir}/%{name}/modules/snmp.so

#=============================================================================
%package		sodium
Summary		:	Wrapper for the Sodium cryptographic library
License		:	PHP

BuildRequires	:	pkgconfig(libsodium) >= 1.0.9

Requires	:	%{name}			= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		sodium
The php-sodium package provides a simple, low-level 
PHP extension for the libsodium cryptographic library.

#-----------------------------------------------------------------------------
%files			sodium
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-sodium.ini
%{_libdir}/%{name}/modules/sodium.so

#=============================================================================
%package		xml
Summary		:	A module for PHP applications which use XML
License		:	PHP

BuildRequires	:	libxml2-devel
BuildRequires	:	libxslt

Requires	:	%{name}			= %{version}-%{release}

Provides	:	%{name}-dom		= %{version}-%{release}
Provides	:	%{name}-simplexml	= %{version}-%{release}
Provides	:	%{name}-xmlreader	= %{version}-%{release}
Provides	:	%{name}-xmlwriter	= %{version}-%{release}
Provides	:	%{name}-xsl		= %{version}-%{release}


#-----------------------------------------------------------------------------
%description		xml
The php-xml package contains dynamic shared objects which add support
to PHP for manipulating XML documents using the DOM tree,
and performing XSL transformations on XML documents.

#-----------------------------------------------------------------------------
%files			xml
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.d/20-dom.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-simplexml.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-xml.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-xmlwriter.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/30-xmlreader.ini
%config(noreplace) %{_sysconfdir}/%{name}.d/20-xsl.ini
%{_libdir}/%{name}/modules/dom.so
%{_libdir}/%{name}/modules/simplexml.so
%{_libdir}/%{name}/modules/xml.so
%{_libdir}/%{name}/modules/xmlreader.so
%{_libdir}/%{name}/modules/xmlwriter.so
%{_libdir}/%{name}/modules/xsl.so

#=============================================================================
%prep
%setup -q -n %{name}-%{version}

tar xf %{SOURCE1}

autoconf

# Disable failing tests
rm tests/output/stream_isatty_*.phpt
rm Zend/tests/arginfo_zpp_mismatch*.phpt

#-----------------------------------------------------------------------------
#building application
%build

export	stdcfg="							\
        	--prefix=%{_prefix}					\
		--exec-prefix=%{_exec_prefix}				\
        	--includedir=%{_includedir}				\
        	--sysconfdir=%{_sysconfdir}/%{name}			\
        	--sbindir=%{_sbindir}					\
		--mandir=%{_mandir}					\
		--libdir=%{_libdir}/%{name}				\
		--infodir=%{_infodir}					\
		--docdir=%{_defaultdocdir}/%{name}-%{version}		\
		--datadir=%{_datadir}/%{name}				\
		--localstatedir=%{_var}					\
		--with-config-file-scan-dir=%{_sysconfdir}/%{name}.d	\
		--with-config-file-path=%{_sysconfdir}			\
	       "

export	phpcfg="							\
		--enable-bcmath						\
		--enable-calendar=shared				\
		--enable-cli						\
		--enable-ctype=shared					\
		--enable-dba=shared					\
		--enable-dom=shared					\
		--enable-exif=shared					\
		--enable-fileinfo=shared				\
		--enable-gd=shared					\
		--with-external-gd					\
		--enable-ftp=shared					\
		--enable-flatfile					\
		--enable-inifile					\
		--enable-intl=shared					\
		--enable-maintainer-zts					\
		--enable-mbstring=shared				\
		--enable-mbregex					\
		--enable-mysqlnd=shared 				\
		--enable-pcntl						\
		--enable-pdo=shared					\
		--enable-phar=shared					\
		--enable-posix=shared					\
		--enable-shmop=shared					\
		--enable-simplexml=shared				\
		--enable-sockets=shared					\
		--enable-sysvmsg=shared					\
		--enable-sysvshm=shared					\
		--enable-sysvsem=shared					\
		--enable-tokenizer=shared 				\
      		--enable-xml=shared 					\
		--enable-xmlreader=shared				\
		--enable-xmlwriter=shared				\
		--disable-opcache					\
		--disable-debug						\
		--disable-rpath						\
		--with-layout=GNU					\
		--with-bz2=shared					\
		--with-curl=shared					\
		--with-enchant=shared					\
		--with-gdbm						\
		--with-gettext=shared					\
		--with-gmp=shared					\
		--with-iconv=shared					\
		--with-ldap=shared					\
		--with-ldap-sasl					\
		--with-mysql-sock=/run/mysqld/mysqld.sock		\
		--with-mysqli=shared,mysqlnd				\
		--with-openssl						\
		--with-pdo-odbc=shared,unixODBC,%{_prefix}		\
		--with-pdo-mysql=shared,mysqlnd	 			\
		--with-pdo-pgsql=shared,%{_prefix}			\
		--with-pdo-sqlite=shared				\
		--with-pgsql=shared					\
		--with-readline						\
		--with-sqlite3=shared					\
		--with-snmp=shared					\
		--with-sodium=shared					\
		--with-xsl=shared,%{_prefix}				\
		--with-zlib=shared					\
		--without-pear						\
	       "

EXTENSION_DIR=%{_libdir}/%{name}/modules
export EXTENSION_DIR

#building the standard php
%{__mkdir} standard
pushd standard
%{__ln_s} ../configure .
./configure							\
	${stdcfg}						\
	--enable-cgi						\
	--enable-fpm						\
	--with-fpm-acl						\
	--with-fpm-user=%{appname}				\
	--with-fpm-group=%{appname}				\
	--enable-embed=shared					\
	${phpcfg}						\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}
popd 

#building the apache (httpd) php component.
cp -a standard std-apache
pushd std-apache
./configure							\
	${stdcfg}						\
	--with-apxs2						\
	${phpcfg}						\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}
popd 

#building the phpdbg component.
cp -a standard std-phpdbg
pushd std-phpdbg
./configure							\
	${stdcfg}						\
	--enable-phpdbg						\
	${phpcfg}						\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

#_____________________________________________________________________________
#part for module php
pushd standard
%{__make}							\
	-j 1							\
	INSTALL_ROOT=%{buildroot}				\
	install-{modules,build,headers,programs,pharcmd}

popd

#installing session directory
install -m 700 -d %{buildroot}%{_sharedstatedir}/%{name}/session

#installing php.ini file
install -D -m644						\
	%{name}.ini-production					\
	%{buildroot}%{_sysconfdir}/%{name}.ini

#To set php init with default time zone
sed -i								\
  -e 's/^extension=zip/;extension=zip/'				\
  -e 's/^extension=curl/;extension=curl/'			\
  -e '/^;date.timezone =/a date.timezone = "America/New_York"'	\
  -e 's/^memory_limit =.*$/memory_limit = 500M/'		\
  -e 's/^max_execution_time =.*$/max_execution_time = 100/'	\
  %{buildroot}%{_sysconfdir}/%{name}.ini

# remove static modules
%{__rm} -f %{buildroot}%{_libdir}/%{name}/modules/*.a

# remove modules provided by sub packages
pushd %{buildroot}%{_libdir}/%{name}/modules
%{__rm} -f 							\
	dom.so							\
	enchant.so						\
	gd.so							\
	gmp.so							\
	intl.so							\
	ldap.so							\
	mysql*.so						\
	pgsql.so						\
	pdo.so							\
	pdo_odbc.so						\
	pdo_pgsql.so						\
	pdo_sqlite.so						\
	pspell.so						\
	simplexml.so						\
	snmp.so							\
	sqlite3.so						\
	sodium.so						\
	tidy.so							\
	xml.so							\
	xmlreader.so						\
	xmlwriter.so						\
	xsl.so
popd


#basic module load
install -d -m755 						\
	%{buildroot}%{_sysconfdir}/%{name}.d

for mod in							\
		bz2						\
		calendar					\
		ctype						\
		curl						\
		dba						\
		exif						\
		fileinfo					\
		ftp						\
		gettext						\
		iconv						\
		mbstring					\
		phar						\
		posix						\
		shmop						\
		sockets						\
		sysvmsg						\
		sysvsem						\
		sysvshm						\
		tokenizer					\
		zlib
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing CGI+CLI module
pushd standard
%{__make}							\
	-j 1							\
	INSTALL_ROOT=%{buildroot}				\
	install-{cli,cgi}

popd
#_____________________________________________________________________________
#installing apache module
pushd std-apache
install	-D -m 755						\
	libs/libphp.so						\
	%{buildroot}%{_httpd_moddir}/libphp.so
popd

install	-D -m 644						\
	%{name}-ok_addon/php.conf				\
	%{buildroot}%{_sysconfdir}/httpd/conf.d/php.conf

#_____________________________________________________________________________
#installing debugger module
pushd std-phpdbg
%{__make}							\
	-j 1							\
	INSTALL_ROOT=%{buildroot}				\
	install-phpdbg
popd

#_____________________________________________________________________________
#installing enchant
install -D -m755						\
	standard/modules/enchant.so				\
	%{buildroot}%{_libdir}/%{name}/modules/enchant.so

for mod in enchant
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing fpm
pushd standard
%{__make}							\
	-j 1							\
	INSTALL_ROOT=%{buildroot}				\
	install-fpm

popd

#To prevent %doc confusion over LICENSE files
cp sapi/fpm/LICENSE fpm_LICENSE

#installing configuration file
install -m 755							\
	-d %{buildroot}%{_sysconfdir}/%{name}/%{name}-fpm.d
%{__rm} -f							\
	%{buildroot}%{_sysconfdir}/%{name}/%{name}-fpm.conf.default
install -m 644							\
	%{name}-ok_addon/%{name}-fpm.conf			\
	%{buildroot}%{_sysconfdir}/%{name}/

%{__rm} -f							\
	%{buildroot}%{_sysconfdir}/%{name}/%{name}-fpm.d/www.conf.default
install -m 644							\
	%{name}-ok_addon/php-fpm-www.conf			\
	 %{buildroot}%{_sysconfdir}/%{name}/%{name}-fpm.d/www.conf

#installing initfile
install -m 755							\
	-d %{buildroot}%{_sysconfdir}/rc.d/init.d
install -m 755							\
	%{name}-ok_addon/%{name}-fpm.init			\
	 %{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}-fpm

#installing log directory
install -m 755							\
	-d %{buildroot}%{_var}/log/%{name}-fpm/

#installing configuration rotation file
install -m 755							\
	-d %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644							\
	%{name}-ok_addon/%{name}-fpm.lr				\
	%{buildroot}%{_sysconfdir}/logrotate.d/
#_____________________________________________________________________________
#installing gd
install -D -m755						\
	standard/modules/gd.so					\
	%{buildroot}%{_libdir}/%{name}/modules/gd.so

for mod in gd
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing gmp
install -D -m755						\
	standard/modules/gmp.so					\
	%{buildroot}%{_libdir}/%{name}/modules/gmp.so

for mod in gmp
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing intl
install -D -m755						\
	standard/modules/intl.so				\
	%{buildroot}%{_libdir}/%{name}/modules/intl.so

for mod in intl
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing ldap
install -D -m755						\
	standard/modules/ldap.so				\
	%{buildroot}%{_libdir}/%{name}/modules/ldap.so

for mod in ldap
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

#_____________________________________________________________________________
#installing mysqlnd
install -D -m755						\
	standard/modules/mysqli.so				\
	standard/modules/mysqlnd.so				\
	standard/modules/pdo_mysql.so				\
	%{buildroot}%{_libdir}/%{name}/modules

for mod in mysqlnd
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done
for mod in pdo_mysql mysqli
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/30-$mod.ini;
  done
  
	
#_____________________________________________________________________________
#installing odbc
install -D -m755						\
	standard/modules/pdo_odbc.so				\
	%{buildroot}%{_libdir}/%{name}/modules/pdo_odbc.so

for mod in pdo_odbc
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/30-$mod.ini;
  done
  
#_____________________________________________________________________________
#installing pdo
install -D -m755						\
	standard/modules/pdo.so					\
	standard/modules/pdo_sqlite.so				\
	standard/modules/sqlite3.so				\
	%{buildroot}%{_libdir}/%{name}/modules

for mod in pdo sqlite3
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done
for mod in pdo_sqlite
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/30-$mod.ini;
  done
  
	
#_____________________________________________________________________________
#installing pgsql
install -D -m755						\
	standard/modules/pgsql.so				\
	standard/modules/pdo_pgsql.so				\
	%{buildroot}%{_libdir}/%{name}/modules

for mod in pgsql
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done
for mod in pdo_pgsql
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/30-$mod.ini;
  done
#_____________________________________________________________________________
#installing snmp
install -D -m755						\
	standard/modules/snmp.so				\
	%{buildroot}%{_libdir}/%{name}/modules/snmp.so

for mod in snmp
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done
#_____________________________________________________________________________
#installing sodium
install -D -m755						\
	standard/modules/sodium.so				\
	%{buildroot}%{_libdir}/%{name}/modules/sodium.so

for mod in sodium
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done
#_____________________________________________________________________________
#installing xml
install -D -m755						\
	standard/modules/dom.so					\
	standard/modules/simplexml.so				\
	standard/modules/xml.so					\
	standard/modules/xmlreader.so				\
	standard/modules/xmlwriter.so				\
	standard/modules/xsl.so					\
	%{buildroot}%{_libdir}/%{name}/modules

for mod in dom simplexml xml xmlwriter xsl
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/20-$mod.ini;
  done

for mod in xmlreader
  do
  sed -e "s/@@MODULE@@/$mod/"					\
	%{name}-ok_addon/extension.tpl				\
	> %{buildroot}%{_sysconfdir}/%{name}.d/30-$mod.ini;
  done

#-----------------------------------------------------------------------------
%changelog
